//+-------------------------------------------------------------------------------------+
//|                                                                  MorningFlat_V3.mq4 |
//|                                                                           Scriptong |
//|                                                                                     |
//+-------------------------------------------------------------------------------------+
#property copyright "Scriptong"
#property link      ""

//       
//       

#property indicator_chart_window
// +2
#property indicator_buffers 10

#property indicator_color1 Red
#property indicator_color2 Red
#property indicator_color3 DarkGray
#property indicator_color4 DarkGray

//         
#property indicator_color5 DarkGray
#property indicator_color6 DarkGray

#property indicator_color7 DarkGray
#property indicator_color8 DarkGray


extern int StartHour = 0;
extern int StartMinute = 15;
extern int EndHour = 8;
extern int EndMinute = 00;
extern double TargetLevel = 161.8;

//  ,     TargetLevel2 
extern double TargetLevel1 = 211.0;
extern double TargetLevel2 = 311.0;

extern color UpColor = Red;
extern color DnColor = Red;
extern color TargetUpColor = DarkGray;
extern color TargetDnColor = DarkGray;

//---- buffers
double Up[];
double Down[];
double Up1[];
double Down1[];
double TargetUp[];
double TargetDn[];

//    
double TargetUp1[];
double TargetDn1[];
double TargetUp2[];
double TargetDn2[];
double TargetUp3[];
double TargetDn3[];
bool Activate = False;
datetime LastDay;
//+-------------------------------------------------------------------------------------+
//| Custom indicator initialization function                                            |
//+-------------------------------------------------------------------------------------+
int init()
  {
//---- indicators
   if(Period() > PERIOD_H1) 
     {
      Comment("     H4!");
      return(0);   
     }

   if(StartHour < 0 || EndHour < 0 || StartHour > 23 || EndHour > 23 || 
      StartHour > EndHour || (StartHour == EndHour && StartMinute >= EndMinute))
     {
      Comment(" StartHour  EndHour      0  24  ",
              "StartHour < EndHour.");
      return(0);
     } 
    
   if(StartMinute < 0 || EndMinute < 0 || StartMinute > 59 || EndMinute > 59)
     {
      Comment(" StartHour  EndHour      0  24  ",
              "StartHour < EndHour.");
      return(0);
     } 

   SetIndexStyle(0,DRAW_LINE);
   SetIndexBuffer(0,Up);
   SetIndexStyle(1,DRAW_LINE);
   SetIndexBuffer(1,Down);
   SetIndexStyle(2,DRAW_LINE);
   SetIndexBuffer(2,TargetUp);
   SetIndexStyle(3,DRAW_LINE);
   SetIndexBuffer(3,TargetDn);

//  4          (
   SetIndexStyle(4,DRAW_LINE);
   SetIndexBuffer(4,TargetUp1);
   SetIndexStyle(5,DRAW_LINE);
   SetIndexBuffer(5,TargetDn1);

   SetIndexStyle(6,DRAW_LINE);
   SetIndexBuffer(6,TargetUp2);
   SetIndexStyle(7,DRAW_LINE);
   SetIndexBuffer(7,TargetDn2);


   SetIndexStyle(8,DRAW_LINE);
   SetIndexBuffer(8,TargetUp3);
   SetIndexStyle(9,DRAW_LINE);
   SetIndexBuffer(9,TargetDn3);


   SetIndexEmptyValue(0, 0.0);
   SetIndexEmptyValue(1, 0.0);
   SetIndexEmptyValue(2, 0.0);
   SetIndexEmptyValue(3, 0.0);

//     
   SetIndexEmptyValue(4, 0.0);
   SetIndexEmptyValue(5, 0.0);
   
   SetIndexEmptyValue(6, 0.0);
   SetIndexEmptyValue(7, 0.0);

   SetIndexEmptyValue(8, 0.0);
   SetIndexEmptyValue(9, 0.0);
   Activate = True;
//----
   return(0);
  }
//+-------------------------------------------------------------------------------------+
//| Custom indicator deinitialization function                                          |
//+-------------------------------------------------------------------------------------+
int deinit()
  {
//----
   //   - 
   for (int i = ObjectsTotal()-1; i >= 0; i--)
     { 
      string Name = ObjectName(i);
      if (StringSubstr(Name, 0, 3) == "Lab")
        ObjectDelete(Name);
     }
   Comment("");
//----
   return(0);
  }

//+-------------------------------------------------------------------------------------+
//|                                                        |
//+-------------------------------------------------------------------------------------+
void DrawLabel(datetime TimeL, double Price, bool Upper, color Col, int Code)
{
 if(Upper)
   string Name = "Lab"+DoubleToStr(TimeL, 0)+"U";
  else
   Name = "Lab"+DoubleToStr(TimeL, 0)+"D"; 

 if(ObjectCreate(Name, OBJ_ARROW, 0, TimeL, Price))
   {
    ObjectSet(Name, OBJPROP_ARROWCODE, Code);
    ObjectSet(Name, OBJPROP_COLOR, Col);
   } 
}
  
//+-------------------------------------------------------------------------------------+
//|                                                                  |
//+-------------------------------------------------------------------------------------+
void DrawText(datetime TimeL, double Price, string St, color Col)
{
 string Name = "LabWidth"+DoubleToStr(TimeL, 0);

 if (ObjectCreate(Name, OBJ_TEXT, 0, TimeL, Price))
   ObjectSetText(Name, St, 10, "Arial", Col);
}  
  
//+-------------------------------------------------------------------------------------+
//| Custom indicator iteration function                                                 |
//+-------------------------------------------------------------------------------------+
int start()
  {
//----
   if (!Activate) return(0);

   LastDay = 0;
   int counted_bars = IndicatorCounted();
   if (counted_bars>0) counted_bars--;
   int limit = Bars - counted_bars;
   for (int i=limit; i>=0; i--)
     if (TimeHour(Time[i]) > EndHour || 
         (TimeMinute(Time[i]) > EndMinute && TimeHour(Time[i]) == EndHour))
       {

         datetime BeginDay = iTime(Symbol(), PERIOD_D1,    //    
                                  iBarShift(Symbol(), PERIOD_D1, Time[i]));   
         datetime NextDay = BeginDay+86400;      //     
         if (LastDay >= BeginDay)             //       , 
           continue;                                         //    
         // ,         
         int StartBar = iBarShift(Symbol(), 0, BeginDay+StartHour*3600+StartMinute*60);
         // ,    " "
         int FinishBar = iBarShift(Symbol(), 0, BeginDay+EndHour*3600+EndMinute*60)+1; 
         
         double LowV = Low[iLowest(Symbol(), 0, MODE_LOW, StartBar-FinishBar+1, // 
                          FinishBar)];                                  //  
         double HighV = High[iHighest(Symbol(), 0, MODE_HIGH, StartBar-FinishBar+1,
                            FinishBar)];                        //   

         double TargetU = (HighV-LowV)*(TargetLevel-100)/100+HighV;       //  
         double TargetD = LowV-(HighV-LowV)*(TargetLevel-100)/100;         //  

//  2    (+1  )
         double TargetU1 = (HighV-LowV)*(TargetLevel1-100)/100+HighV;       //  
         double TargetD1 = LowV-(HighV-LowV)*(TargetLevel1-100)/100;         //  

         double TargetU2 = (HighV-LowV)*(TargetLevel2-100)/100+HighV;       //  
         double TargetD2 = LowV-(HighV-LowV)*(TargetLevel2-100)/100;         //  
        
         
         //   " "
         for(int j = StartBar; j >= FinishBar; j--)
           {
            Up[j] = HighV;
            Down[j] = LowV;
           }
         // -----------------------
         
         //       
         for(j = FinishBar; Time[j] < NextDay && j >= 0; j--)
           {
            TargetUp[j] = TargetU;
            TargetDn[j] = TargetD;

//  2    (+1  )
            TargetUp1[j] = TargetU1;
            TargetDn1[j] = TargetD1;

            TargetUp2[j] = TargetU2;
            TargetDn2[j] = TargetD2;

                       

           }
         // -------------------  

           
         datetime TB = Time[iBarShift(Symbol(), 0, BeginDay + StartHour*3600 + 
                                      StartMinute*60)];
         DrawLabel(TB, HighV, True, UpColor, 5);   //     
         DrawLabel(TB, LowV, False, DnColor, 5);    //     
         //     
         DrawLabel(Time[FinishBar], TargetU, True, TargetUpColor, 5);   

//   ( +1   "Time[FinishBar]+1"  1  +1
         DrawLabel(Time[FinishBar]+1, TargetU1, True, TargetUpColor, 5);   
         DrawLabel(Time[FinishBar]+2, TargetU2, True, TargetUpColor, 5);   
        
         //     
         DrawLabel(Time[FinishBar], TargetD, False, TargetDnColor, 5);   

//   ( +1   "Time[FinishBar]+1"  1  +1
         DrawLabel(Time[FinishBar]+1, TargetD1, False, TargetDnColor, 5);   
         DrawLabel(Time[FinishBar]+2, TargetD2, False, TargetDnColor, 5);   
         

         DrawText((Time[FinishBar] - TB)/2 + TB, HighV,      //   
                   DoubleToStr(MathRound((HighV-LowV)/Point), 0), Red);
         LastDay = BeginDay;      // ,        


       }

   WindowRedraw();
//----
   return(0);
  }
//+------------------------------------------------------------------+